/* markers.c generated by valac 0.10.0, the Vala compiler
 * generated from markers.vala, do not modify */

/*
 * Copyright (C) 2010 Simon Wenner <simon@wenner.ch>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <champlain/champlain.h>
#include <clutter/clutter.h>
#include <pango/pango.h>


#define TYPE_MARKER_LAYER (marker_layer_get_type ())
#define MARKER_LAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER_LAYER, MarkerLayer))
#define MARKER_LAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MARKER_LAYER, MarkerLayerClass))
#define IS_MARKER_LAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER_LAYER))
#define IS_MARKER_LAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MARKER_LAYER))
#define MARKER_LAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MARKER_LAYER, MarkerLayerClass))

typedef struct _MarkerLayer MarkerLayer;
typedef struct _MarkerLayerClass MarkerLayerClass;
typedef struct _MarkerLayerPrivate MarkerLayerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MarkerLayer {
	ChamplainSelectionLayer parent_instance;
	MarkerLayerPrivate * priv;
};

struct _MarkerLayerClass {
	ChamplainSelectionLayerClass parent_class;
};


static gpointer marker_layer_parent_class = NULL;

GType marker_layer_get_type (void) G_GNUC_CONST;
enum  {
	MARKER_LAYER_DUMMY_PROPERTY
};
MarkerLayer* marker_layer_new (void);
MarkerLayer* marker_layer_construct (GType object_type);



MarkerLayer* marker_layer_construct (GType object_type) {
	MarkerLayer * self;
	ClutterColor _tmp0_ = {0};
	ClutterColor orange;
	ChamplainMarker* marker;
	GError * _inner_error_ = NULL;
	self = g_object_newv (object_type, 0, NULL);
	orange = (_tmp0_.red = (guchar) 0xf3, _tmp0_.green = (guchar) 0x94, _tmp0_.blue = (guchar) 0x07, _tmp0_.alpha = (guchar) 0xbb, _tmp0_);
	marker = g_object_ref_sink ((ChamplainMarker*) champlain_marker_new_with_text ("Montréal\n<span size=\"xx-small\">Québec</span>", "Serif 14", NULL, NULL));
	champlain_marker_set_use_markup (marker, TRUE);
	champlain_marker_set_alignment (marker, PANGO_ALIGN_RIGHT);
	champlain_marker_set_color (marker, &orange);
	champlain_base_marker_set_position ((ChamplainBaseMarker*) marker, 45.528178, -73.563788);
	champlain_layer_add_marker ((ChamplainLayer*) self, (ChamplainBaseMarker*) marker);
	{
		ChamplainMarker* _tmp1_;
		ChamplainMarker* _tmp2_;
		_tmp1_ = g_object_ref_sink ((ChamplainMarker*) champlain_marker_new_from_file ("/usr/share/icons/gnome/24x24/emblems/emblem-generic.png", &_inner_error_));
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		marker = (_tmp2_ = g_object_ref_sink (_tmp1_), _g_object_unref0 (marker), _tmp2_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("markers.vala:40: %s", e->message);
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (marker);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	champlain_marker_set_text (marker, "New York");
	champlain_base_marker_set_position ((ChamplainBaseMarker*) marker, 40.77, -73.98);
	champlain_layer_add_marker ((ChamplainLayer*) self, (ChamplainBaseMarker*) marker);
	{
		ChamplainMarker* _tmp3_;
		ChamplainMarker* _tmp4_;
		_tmp3_ = g_object_ref_sink ((ChamplainMarker*) champlain_marker_new_from_file ("/usr/share/icons/gnome/24x24/emblems/emblem-important.png", &_inner_error_));
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		marker = (_tmp4_ = g_object_ref_sink (_tmp3_), _g_object_unref0 (marker), _tmp4_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("markers.vala:50: %s", e->message);
			_g_error_free0 (e);
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (marker);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	champlain_base_marker_set_position ((ChamplainBaseMarker*) marker, 47.130885, -70.764141);
	champlain_layer_add_marker ((ChamplainLayer*) self, (ChamplainBaseMarker*) marker);
	{
		ChamplainMarker* _tmp5_;
		ChamplainMarker* _tmp6_;
		_tmp5_ = g_object_ref_sink ((ChamplainMarker*) champlain_marker_new_from_file ("/usr/share/icons/gnome/24x24/emblems/emblem-favorite.png", &_inner_error_));
		if (_inner_error_ != NULL) {
			goto __catch2_g_error;
		}
		marker = (_tmp6_ = g_object_ref_sink (_tmp5_), _g_object_unref0 (marker), _tmp6_);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_warning ("markers.vala:59: %s", e->message);
			_g_error_free0 (e);
		}
	}
	__finally2:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (marker);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	champlain_marker_set_draw_background (marker, FALSE);
	champlain_base_marker_set_position ((ChamplainBaseMarker*) marker, 45.41484, -71.918907);
	champlain_layer_add_marker ((ChamplainLayer*) self, (ChamplainBaseMarker*) marker);
	_g_object_unref0 (marker);
	return self;
}


MarkerLayer* marker_layer_new (void) {
	return marker_layer_construct (TYPE_MARKER_LAYER);
}


static void marker_layer_class_init (MarkerLayerClass * klass) {
	marker_layer_parent_class = g_type_class_peek_parent (klass);
}


static void marker_layer_instance_init (MarkerLayer * self) {
}


GType marker_layer_get_type (void) {
	static volatile gsize marker_layer_type_id__volatile = 0;
	if (g_once_init_enter (&marker_layer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MarkerLayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) marker_layer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MarkerLayer), 0, (GInstanceInitFunc) marker_layer_instance_init, NULL };
		GType marker_layer_type_id;
		marker_layer_type_id = g_type_register_static (CHAMPLAIN_TYPE_SELECTION_LAYER, "MarkerLayer", &g_define_type_info, 0);
		g_once_init_leave (&marker_layer_type_id__volatile, marker_layer_type_id);
	}
	return marker_layer_type_id__volatile;
}




